;
; track and field patch loader
; mailto:jp@drumfu.com
; july 2011
;
; patch to original speedlock release of
; track and field
; bugfix by mr. anonymous
; as discussed within the WoS forums
; http://www.worldofspectrum.org/forums/showthread.php?t=34295
;
; bit of a dirty hack - contains decrypted loader
;
	org $fb7a
;
main	ld ix, $0000
	ld de, $1424
	ld a,$ff
	scf
	call $0556
	jr nc,main		; throw basic away

	ld sp, $ffff
	ld ix, $fee8		; setup and load
	ld de, $00e8		; first speedlock
	call l_fe40		; block
;
	xor a			; mimic what
	ld ($82ff),a		; speedlock
	ld ix,$4000		; block 1
	ld de,$17ff		; is doing
	ld hl,$fdb3
	ld ($fdb1),hl
	call l_fcf6		
;
	ld hl,patch
	ld de,$ff2a
	ld bc,epatch-patch
	ldir			; copy patch and
	jp $fefc		; restart loading
;
patch	ld a,$c9		; force routine
	ld ($fe50),a		; at $fe40 to return
	call $fe40
	ld a,$06		; mr. anonymous
	ld (26178),a		; bugfix
	jp $5f00		; start game
epatch	equ $
;


; decrypted loader
;
	org $fbc8
;
	jp l_fecd		 ; fbc8 c3 cd fe $0ats
l_fbcb: ld ix, $fbc4		 ; fbcb dd 21 c4 fb $0ets
l_fbcf: ld (ix+$13), $00	 ; fbcf dd 36 13 00 $13ts
	inc ix			 ; fbd3 dd 23 $0ats
	jr l_fbcf		 ; fbd5 18 f8 $0cts
l_fbd7: exx			 ; fbd7 d9 $04ts
	ex af, af'		 ; fbd8 08 $04ts
	ld a, ($82ff)		 ; fbd9 3a ff 82 $0dts
	cp $00			 ; fbdc fe 00 $07ts
	ld b, $0c		 ; fbde 06 0c $07ts
	jr z, l_fbf9		 ; fbe0 28 17 $0c/$07ts
	ld hl, l_fbfc		 ; fbe2 21 fc fb $0ats
	ld ($fd9a), hl		 ; fbe5 22 9a fd $10ts
	ld hl, $8000		 ; fbe8 21 00 80 $0ats
	ld de, $5800		 ; fbeb 11 00 58 $0ats
	ld a, $41		 ; fbee 3e 41 $07ts
	ld b, $09		 ; fbf0 06 09 $07ts
l_fbf2: djnz l_fbf2		 ; fbf2 10 fe $08/$0dts
	ex af, af'		 ; fbf4 08 $04ts
	exx			 ; fbf5 d9 $04ts
	jp l_fcde		 ; fbf6 c3 de fc $0ats
l_fbf9: nop			 ; fbf9 00 $04ts
	jr l_fbf2		 ; fbfa 18 f6 $0cts
l_fbfc: exx			 ; fbfc d9 $04ts
	ex af, af'		 ; fbfd 08 $04ts
	dec a			 ; fbfe 3d $04ts
	jr z, l_fc1f		 ; fbff 28 1e $0c/$07ts
	ex af, af'		 ; fc01 08 $04ts
	ldi			 ; fc02 ed a0 $10ts
	ldi			 ; fc04 ed a0 $10ts
	ldi			 ; fc06 ed a0 $10ts
	ldi			 ; fc08 ed a0 $10ts
	ldi			 ; fc0a ed a0 $10ts
	ldi			 ; fc0c ed a0 $10ts
	ldi			 ; fc0e ed a0 $10ts
	ldi			 ; fc10 ed a0 $10ts
	ldi			 ; fc12 ed a0 $10ts
	ldi			 ; fc14 ed a0 $10ts
	ldi			 ; fc16 ed a0 $10ts
	ldi			 ; fc18 ed a0 $10ts
	nop			 ; fc1a 00 $04ts
	exx			 ; fc1b d9 $04ts
	jp l_fcde		 ; fc1c c3 de fc $0ats
l_fc1f: ld a, $01		 ; fc1f 3e 01 $07ts
	ex af, af'		 ; fc21 08 $04ts
	ld hl, l_fc3d		 ; fc22 21 3d fc $0ats
	ld ($fd9a), hl		 ; fc25 22 9a fd $10ts
	xor a			 ; fc28 af $04ts
	ld ($fcef), a		 ; fc29 32 ef fc $0dts
	ld a, $08		 ; fc2c 3e 08 $07ts
	ld ($fcf1), a		 ; fc2e 32 f1 fc $0dts
	ld b, $08		 ; fc31 06 08 $07ts
	ld b, $08		 ; fc33 06 08 $07ts
	ld b, $08		 ; fc35 06 08 $07ts
l_fc37: djnz l_fc37		 ; fc37 10 fe $08/$0dts
	exx			 ; fc39 d9 $04ts
	jp l_fcde		 ; fc3a c3 de fc $0ats
l_fc3d: exx			 ; fc3d d9 $04ts
	ex af, af'		 ; fc3e 08 $04ts
	cp $98			 ; fc3f fe 98 $07ts
	jr c, l_fca0		 ; fc41 38 5d $0c/$07ts
	dec c			 ; fc43 0d $04ts
	jr z, l_fc54		 ; fc44 28 0e $0c/$07ts
	ex af, af'		 ; fc46 08 $04ts
	ld b, $04		 ; fc47 06 04 $07ts
l_fc49: ld a, (hl)		 ; fc49 7e $07ts
	ld (de), a		 ; fc4a 12 $07ts
	inc hl			 ; fc4b 23 $06ts
	inc d			 ; fc4c 14 $04ts
	djnz l_fc49		 ; fc4d 10 fa $08/$0dts
	nop			 ; fc4f 00 $04ts
	ld b, $01		 ; fc50 06 01 $07ts
	jr l_fc8d		 ; fc52 18 39 $0cts
l_fc54: dec a			 ; fc54 3d $04ts
	cp $98			 ; fc55 fe 98 $07ts
	jr c, l_fc93		 ; fc57 38 3a $0c/$07ts
	ld c, $03		 ; fc59 0e 03 $07ts
	ld hl, l_fcd4		 ; fc5b 21 d4 fc $0ats
	ld de, $401f		 ; fc5e 11 1f 40 $0ats
	ld b, $08		 ; fc61 06 08 $07ts
	jr z, l_fc80		 ; fc63 28 1b $0c/$07ts
	dec hl			 ; fc65 2b $06ts
	dec e			 ; fc66 1d $04ts
	dec e			 ; fc67 1d $04ts
	nop			 ; fc68 00 $04ts
	nop			 ; fc69 00 $04ts
	ld b, $05		 ; fc6a 06 05 $07ts
	cp $99			 ; fc6c fe 99 $07ts
	jr z, l_fc80		 ; fc6e 28 10 $0c/$07ts
	dec hl			 ; fc70 2b $06ts
	dec e			 ; fc71 1d $04ts
	nop			 ; fc72 00 $04ts
	ld b, $03		 ; fc73 06 03 $07ts
	cp $9a			 ; fc75 fe 9a $07ts
	jr z, l_fc80		 ; fc77 28 07 $0c/$07ts
	dec hl			 ; fc79 2b $06ts
	dec e			 ; fc7a 1d $04ts
	dec e			 ; fc7b 1d $04ts
	nop			 ; fc7c 00 $04ts
	nop			 ; fc7d 00 $04ts
	ld b, $01		 ; fc7e 06 01 $07ts
l_fc80: djnz l_fc80		 ; fc80 10 fe $08/$0dts
	ld l, (hl)		 ; fc82 6e $07ts
	ld h, $ff		 ; fc83 26 ff $07ts
	ex af, af'		 ; fc85 08 $04ts
	exx			 ; fc86 d9 $04ts
	jp l_fcde		 ; fc87 c3 de fc $0ats
l_fc8a: ld b, $0d		 ; fc8a 06 0d $07ts
l_fc8c: ex af, af'		 ; fc8c 08 $04ts
l_fc8d: djnz l_fc8d		 ; fc8d 10 fe $08/$0dts
	exx			 ; fc8f d9 $04ts
	jp l_fcde		 ; fc90 c3 de fc $0ats
l_fc93: ld b, $0b		 ; fc93 06 0b $07ts
	jr l_fc8c		 ; fc95 18 f5 $0cts
l_fc97: ld (hl), a		 ; fc97 77 $07ts
l_fc98: djnz l_fc98		 ; fc98 10 fe $08/$0dts
	jr l_fcca		 ; fc9a 18 2e $0cts
l_fc9c: nop			 ; fc9c 00 $04ts
	nop			 ; fc9d 00 $04ts
	jr l_fcca		 ; fc9e 18 2a $0cts
l_fca0: dec a			 ; fca0 3d $04ts
	jr nz, l_fc8a		 ; fca1 20 e7 $07/$0cts
	ld a, $9c		 ; fca3 3e 9c $07ts
	ex af, af'		 ; fca5 08 $04ts
	ld hl, l_fcd4		 ; fca6 21 d4 fc $0ats
	ld de, $78f8		 ; fca9 11 f8 78 $0ats
	ld a, e			 ; fcac 7b $04ts
	add a, (hl)		 ; fcad 86 $07ts
	cp d			 ; fcae ba $04ts
	ld b, $07		 ; fcaf 06 07 $07ts
	jr nz, l_fc97		 ; fcb1 20 e4 $07/$0cts
	ld (hl), $c8		 ; fcb3 36 c8 $0ats
	dec hl			 ; fcb5 2b $06ts
	ld a, e			 ; fcb6 7b $04ts
	add a, (hl)		 ; fcb7 86 $07ts
	cp d			 ; fcb8 ba $04ts
	ld b, $04		 ; fcb9 06 04 $07ts
	jr nz, l_fc98		 ; fcbb 20 db $07/$0cts
	ld (hl), $c8		 ; fcbd 36 c8 $0ats
	dec hl			 ; fcbf 2b $06ts
	ld a, e			 ; fcc0 7b $04ts
	add a, (hl)		 ; fcc1 86 $07ts
	cp d			 ; fcc2 ba $04ts
	jr nz, l_fc9c		 ; fcc3 20 d7 $07/$0cts
	ld (hl), $a8		 ; fcc5 36 a8 $0ats
	dec hl			 ; fcc7 2b $06ts
	ld a, e			 ; fcc8 7b $04ts
	add a, (hl)		 ; fcc9 86 $07ts
l_fcca: ld (hl), a		 ; fcca 77 $07ts
	ld c, $01		 ; fccb 0e 01 $07ts
	exx			 ; fccd d9 $04ts
	jp l_fcde		 ; fcce c3 de fc $0ats
	adc a, b		 ; fcd1 88 $04ts
	xor b			 ; fcd2 a8 $04ts
	cp b			 ; fcd3 b8 $04ts
l_fcd4: ret nz			 ; fcd4 c0 $05/$0bts
l_fcd5: call l_fcd9		 ; fcd5 cd d9 fc $11ts
	ret nc			 ; fcd8 d0 $05/$0bts
l_fcd9: ld a, $16		 ; fcd9 3e 16 $07ts
l_fcdb: dec a			 ; fcdb 3d $04ts
	jr nz, l_fcdb		 ; fcdc 20 fd $07/$0cts
l_fcde: and a			 ; fcde a7 $04ts
l_fcdf: inc b			 ; fcdf 04 $04ts
	ret z			 ; fce0 c8 $0b/$05ts
	ld a, $7f		 ; fce1 3e 7f $07ts
	in a, ($fe)		 ; fce3 db fe $0bts
	rra			 ; fce5 1f $04ts
	xor c			 ; fce6 a9 $04ts
	and $20			 ; fce7 e6 20 $07ts
	jr z, l_fcdf		 ; fce9 28 f4 $0c/$07ts
	ld a, c			 ; fceb 79 $04ts
	cpl			 ; fcec 2f $04ts
	ld c, a			 ; fced 4f $04ts
	and $07			 ; fcee e6 07 $07ts
	or $08			 ; fcf0 f6 08 $07ts
	out ($fe), a		 ; fcf2 d3 fe $0bts
	scf			 ; fcf4 37 $04ts
	ret			 ; fcf5 c9 $0ats
l_fcf6: di			 ; fcf6 f3 $04ts
	ld a, $02		 ; fcf7 3e 02 $07ts
	ld ($fcef), a		 ; fcf9 32 ef fc $0dts
	or $08			 ; fcfc f6 08 $07ts
	out ($fe), a		 ; fcfe d3 fe $0bts
	ld hl, l_fec3		 ; fd00 21 c3 fe $0ats
	push hl			 ; fd03 e5 $0bts
	in a, ($fe)		 ; fd04 db fe $0bts
	rra			 ; fd06 1f $04ts
	and $20			 ; fd07 e6 20 $07ts
	ld c, a			 ; fd09 4f $04ts
	push de			 ; fd0a d5 $0bts
l_fd0b: ld e, $20		 ; fd0b 1e 20 $07ts
l_fd0d: ld b, $9c		 ; fd0d 06 9c $07ts
	call l_fcd5		 ; fd0f cd d5 fc $11ts
	jr nc, l_fd0b		 ; fd12 30 f7 $07/$0cts
	ld a, $c2		 ; fd14 3e c2 $07ts
	cp b			 ; fd16 b8 $04ts
	jr nc, l_fd0b		 ; fd17 30 f2 $07/$0cts
	dec e			 ; fd19 1d $04ts
	jr nz, l_fd0d		 ; fd1a 20 f1 $07/$0cts
l_fd1c: ld b, $c9		 ; fd1c 06 c9 $07ts
	call l_fcd9		 ; fd1e cd d9 fc $11ts
	jr nc, l_fd0b		 ; fd21 30 e8 $07/$0cts
	ld a, b			 ; fd23 78 $04ts
	cp $d4			 ; fd24 fe d4 $07ts
	jr nc, l_fd1c		 ; fd26 30 f4 $07/$0cts
	call l_fcd9		 ; fd28 cd d9 fc $11ts
	jr nc, l_fd0b		 ; fd2b 30 de $07/$0cts
	ld e, $07		 ; fd2d 1e 07 $07ts
	ld hl, l_feb4		 ; fd2f 21 b4 fe $0ats
l_fd32: ld b, (hl)		 ; fd32 46 $07ts
	inc hl			 ; fd33 23 $06ts
	call l_fcd5		 ; fd34 cd d5 fc $11ts
	jr nc, l_fd0b		 ; fd37 30 d2 $07/$0cts
	ld a, (hl)		 ; fd39 7e $07ts
	inc hl			 ; fd3a 23 $06ts
	cp b			 ; fd3b b8 $04ts
	jr nc, l_fd0b		 ; fd3c 30 cd $07/$0cts
	dec e			 ; fd3e 1d $04ts
	jr nz, l_fd32		 ; fd3f 20 f1 $07/$0cts
	ld a, $01		 ; fd41 3e 01 $07ts
	ld ($fcef), a		 ; fd43 32 ef fc $0dts
	ld b, $9e		 ; fd46 06 9e $07ts
	pop de			 ; fd48 d1 $0ats
	ld l, $04		 ; fd49 2e 04 $07ts
	ld a, $08		 ; fd4b 3e 08 $07ts
	jr l_fd51		 ; fd4d 18 02 $0cts
l_fd4f: ld a, $09		 ; fd4f 3e 09 $07ts
l_fd51: call l_fcdb		 ; fd51 cd db fc $11ts
	ret nc			 ; fd54 d0 $05/$0bts
	nop			 ; fd55 00 $04ts
	nop			 ; fd56 00 $04ts
	ld a, $0e		 ; fd57 3e 0e $07ts
	call l_fcdb		 ; fd59 cd db fc $11ts
	ret nc			 ; fd5c d0 $05/$0bts
	ld a, $13		 ; fd5d 3e 13 $07ts
	ld a, $bc		 ; fd5f 3e bc $07ts
	cp b			 ; fd61 b8 $04ts
	rl l			 ; fd62 cb 15 $08ts
	ld b, $9e		 ; fd64 06 9e $07ts
	jp nc, l_fd4f		 ; fd66 d2 4f fd $0a/$0ats
	ld a, $3a		 ; fd69 3e 3a $07ts
	cp l			 ; fd6b bd $04ts
	jp nz, l_fbcb		 ; fd6c c2 cb fb $0a/$0ats
	ld h, $86		 ; fd6f 26 86 $07ts
	ld h, $00		 ; fd71 26 00 $07ts
	ld b, $b2		 ; fd73 06 b2 $07ts
	ld l, $01		 ; fd75 2e 01 $07ts
	ld iy, $ff49		 ; fd77 fd 21 49 ff $0ets
	ld a, $04		 ; fd7b 3e 04 $07ts
	jr l_fd95		 ; fd7d 18 16 $0cts
l_fd7f: ld a, $c1		 ; fd7f 3e c1 $07ts
	xor l			 ; fd81 ad $04ts
	add a, $11		 ; fd82 c6 11 $07ts
	ld (ix+$00), a		 ; fd84 dd 77 00 $13ts
	inc ix			 ; fd87 dd 23 $0ats
	dec de			 ; fd89 1b $06ts
	ld b, $b2		 ; fd8a 06 b2 $07ts
	ld l, $01		 ; fd8c 2e 01 $07ts
	nop			 ; fd8e 00 $04ts
	ld a, $02		 ; fd8f 3e 02 $07ts
	jr l_fd95		 ; fd91 18 02 $0cts
l_fd93: ld a, $09		 ; fd93 3e 09 $07ts
l_fd95: call l_fcdb		 ; fd95 cd db fc $11ts
	ret nc			 ; fd98 d0 $05/$0bts
	call l_fbd7		 ; fd99 cd d7 fb $11ts
	ret nc			 ; fd9c d0 $05/$0bts
	ld a, $13		 ; fd9d 3e 13 $07ts
	ld a, $d0		 ; fd9f 3e d0 $07ts
	cp b			 ; fda1 b8 $04ts
	rl l			 ; fda2 cb 15 $08ts
	ld b, $b2		 ; fda4 06 b2 $07ts
	jp nc, l_fd93		 ; fda6 d2 93 fd $0a/$0ats
	ld a, h			 ; fda9 7c $04ts
	xor l			 ; fdaa ad $04ts
	ld h, a			 ; fdab 67 $04ts
	ld a, d			 ; fdac 7a $04ts
	or e			 ; fdad b3 $04ts
	jr nz, l_fd7f		 ; fdae 20 cf $07/$0cts
	jp l_fec2		 ; fdb0 c3 c2 fe $0ats
	ld a, $c1		 ; fdb3 3e c1 $07ts
	xor l			 ; fdb5 ad $04ts
	add a, $11		 ; fdb6 c6 11 $07ts
	ld (ix+$00), a		 ; fdb8 dd 77 00 $13ts
	inc ix			 ; fdbb dd 23 $0ats
	dec de			 ; fdbd 1b $06ts
	ld l, $02		 ; fdbe 2e 02 $07ts
	ld a, $04		 ; fdc0 3e 04 $07ts
	ld b, $b3		 ; fdc2 06 b3 $07ts
	call l_fe2a		 ; fdc4 cd 2a fe $11ts
	ret nc			 ; fdc7 d0 $05/$0bts
	ld a, (iy+$04)		 ; fdc8 fd 7e 04 $13ts
	or a			 ; fdcb b7 $04ts
	jr z, l_fe24		 ; fdcc 28 56 $0c/$07ts
	ld l, c			 ; fdce 69 $04ts
	ld bc, $7ffd		 ; fdcf 01 fd 7f $0ats
	out (c), a		 ; fdd2 ed 79 $0cts
	ld c, (iy+$00)		 ; fdd4 fd 4e 00 $13ts
	ld b, (iy+$01)		 ; fdd7 fd 46 01 $13ts
	ld ix, $0000		 ; fdda dd 21 00 00 $0ets
	add ix, bc		 ; fdde dd 09 $0fts
	ld c, l			 ; fde0 4d $04ts
	ld a, $01		 ; fde1 3e 01 $07ts
l_fde3: ld l, $02		 ; fde3 2e 02 $07ts
	ld b, $b3		 ; fde5 06 b3 $07ts
	call l_fe2a		 ; fde7 cd 2a fe $11ts
	ret nc			 ; fdea d0 $05/$0bts
	ld a, $7f		 ; fdeb 3e 7f $07ts
	cp l			 ; fded bd $04ts
	jr z, l_fdf3		 ; fdee 28 03 $0c/$07ts
	ld (l_feb3), a		 ; fdf0 32 b3 fe $0dts
l_fdf3: ld e, (iy+$02)		 ; fdf3 fd 5e 02 $13ts
	ld d, (iy+$03)		 ; fdf6 fd 56 03 $13ts
	ld l, c			 ; fdf9 69 $04ts
	ld bc, $0005		 ; fdfa 01 05 00 $0ats
	add iy, bc		 ; fdfd fd 09 $0fts
	ld c, l			 ; fdff 4d $04ts
	ld l, $02		 ; fe00 2e 02 $07ts
	ld a, $03		 ; fe02 3e 03 $07ts
	ld b, $b3		 ; fe04 06 b3 $07ts
	call l_fe2a		 ; fe06 cd 2a fe $11ts
	ret nc			 ; fe09 d0 $05/$0bts
	ld a, e			 ; fe0a 7b $04ts
	or d			 ; fe0b b2 $04ts
	ld b, $b2		 ; fe0c 06 b2 $07ts
	ld l, $01		 ; fe0e 2e 01 $07ts
	ld a, $06		 ; fe10 3e 06 $07ts
	jp nz, l_fd95		 ; fe12 c2 95 fd $0a/$0ats
	ld de, l_fec2		 ; fe15 11 c2 fe $0ats
	ld ($fdb1), de		 ; fe18 ed 53 b1 fd $14ts
	ld de, $000e		 ; fe1c 11 0e 00 $0ats
	ld a, $02		 ; fe1f 3e 02 $07ts
	jp l_fd95		 ; fe21 c3 95 fd $0ats
l_fe24: ld a, $06		 ; fe24 3e 06 $07ts
	jr l_fde3		 ; fe26 18 bb $0cts
l_fe28: ld a, $0c		 ; fe28 3e 0c $07ts
l_fe2a: call l_fcdb		 ; fe2a cd db fc $11ts
	nop			 ; fe2d 00 $04ts
	nop			 ; fe2e 00 $04ts
	ld a, $0e		 ; fe2f 3e 0e $07ts
	call l_fcdb		 ; fe31 cd db fc $11ts
	ret nc			 ; fe34 d0 $05/$0bts
	ld a, $db		 ; fe35 3e db $07ts
	cp b			 ; fe37 b8 $04ts
	rl l			 ; fe38 cb 15 $08ts
	ld b, $b3		 ; fe3a 06 b3 $07ts
	jp nc, l_fe28		 ; fe3c d2 28 fe $0a/$0ats
	ret			 ; fe3f c9 $0ats
l_fe40: call l_fcf6		 ; fe40 cd f6 fc $11ts
	ld hl, $9000		 ; fe43 21 00 90 $0ats
	ld b, $ff		 ; fe46 06 ff $07ts
l_fe48: push bc			 ; fe48 c5 $0bts
	call l_fe5b		 ; fe49 cd 5b fe $11ts
	ld (hl), e		 ; fe4c 73 $07ts
	inc hl			 ; fe4d 23 $06ts
	pop bc			 ; fe4e c1 $0ats
	djnz l_fe48		 ; fe4f 10 f7 $08/$0dts
	ld a, ($006d)		 ; fe51 3a 6d 00 $0dts
	cp $28			 ; fe54 fe 28 $07ts
	ret z			 ; fe56 c8 $0b/$05ts
	call l_fe77		 ; fe57 cd 77 fe $11ts
	ret			 ; fe5a c9 $0ats
l_fe5b: ld e, $00		 ; fe5b 1e 00 $07ts
	ld c, e			 ; fe5d 4b $04ts
	ld b, $ff		 ; fe5e 06 ff $07ts
l_fe60: ld a, $7f		 ; fe60 3e 7f $07ts
	in a, ($fe)		 ; fe62 db fe $0bts
	and $40			 ; fe64 e6 40 $07ts
	xor c			 ; fe66 a9 $04ts
	jr z, l_fe72		 ; fe67 28 09 $0c/$07ts
	inc e			 ; fe69 1c $04ts
	ld a, c			 ; fe6a 79 $04ts
	cpl			 ; fe6b 2f $04ts
	and $40			 ; fe6c e6 40 $07ts
	ld c, a			 ; fe6e 4f $04ts
l_fe6f: djnz l_fe60		 ; fe6f 10 ef $08/$0dts
	ret			 ; fe71 c9 $0ats
l_fe72: nop			 ; fe72 00 $04ts
	nop			 ; fe73 00 $04ts
	jp l_fe6f		 ; fe74 c3 6f fe $0ats
l_fe77: ld hl, $0000		 ; fe77 21 00 00 $0ats
	ld de, $9032		 ; fe7a 11 32 90 $0ats
	ld b, $32		 ; fe7d 06 32 $07ts
l_fe7f: push bc			 ; fe7f c5 $0bts
	ld a, (de)		 ; fe80 1a $07ts
	ld b, $00		 ; fe81 06 00 $07ts
	ld c, a			 ; fe83 4f $04ts
	add hl, bc		 ; fe84 09 $0bts
	inc de			 ; fe85 13 $06ts
	pop bc			 ; fe86 c1 $0ats
	djnz l_fe7f		 ; fe87 10 f6 $08/$0dts
	push hl			 ; fe89 e5 $0bts
	ld hl, $0000		 ; fe8a 21 00 00 $0ats
	ld de, $90cd		 ; fe8d 11 cd 90 $0ats
	ld b, $32		 ; fe90 06 32 $07ts
l_fe92: push bc			 ; fe92 c5 $0bts
	ld a, (de)		 ; fe93 1a $07ts
	ld b, $00		 ; fe94 06 00 $07ts
	ld c, a			 ; fe96 4f $04ts
	add hl, bc		 ; fe97 09 $0bts
	inc de			 ; fe98 13 $06ts
	pop bc			 ; fe99 c1 $0ats
	djnz l_fe92		 ; fe9a 10 f6 $08/$0dts
	pop bc			 ; fe9c c1 $0ats
	ld a, h			 ; fe9d 7c $04ts
	cp $0d			 ; fe9e fe 0d $07ts
	jr nc, l_feaf		 ; fea0 30 0d $07/$0cts
	and a			 ; fea2 a7 $04ts
	sbc hl, bc		 ; fea3 ed 42 $0fts
	ret c			 ; fea5 d8 $0b/$05ts
	ld bc, $0032		 ; fea6 01 32 00 $0ats
	and a			 ; fea9 a7 $04ts
	sbc hl, bc		 ; feaa ed 42 $0fts
	ret c			 ; feac d8 $0b/$05ts
	ld a, $01		 ; fead 3e 01 $07ts
l_feaf: ld (l_feb3), a		 ; feaf 32 b3 fe $0dts
	ret			 ; feb2 c9 $0ats
l_feb3: nop			 ; feb3 00 $04ts
l_feb4: jp (hl)			 ; feb4 e9 $04ts
	jp pe, $e2d2		 ; feb5 ea d2 e2 $0a/$0ats
	or (hl)			 ; feb8 b6 $07ts
	ret po			 ; feb9 e0 $05/$0bts
	or (hl)			 ; feba b6 $07ts
	ret po			 ; febb e0 $05/$0bts
	or (hl)			 ; febc b6 $07ts
	ret po			 ; febd e0 $05/$0bts
	jp nc, $ece2		 ; febe d2 e2 ec $0a/$0ats
	defb $ed		 ; fec1 ed $04ts
l_fec2: pop de			 ; fec2 d1 $0ats
l_fec3: xor a			 ; fec3 af $04ts
	out ($fe), a		 ; fec4 d3 fe $0bts
	ld a, h			 ; fec6 7c $04ts
	cp $01			 ; fec7 fe 01 $07ts
	ret c			 ; fec9 d8 $0b/$05ts
	call l_fbcb		 ; feca cd cb fb $11ts
l_fecd: ld sp, $ffff		 ; fecd 31 ff ff $0ats
l_fed0:	ld hl, $4000		 ; fed0 21 00 40 $0ats
	ld bc, $001b		 ; fed3 01 1b 00 $0ats
l_fed6: ld (hl), $00		 ; fed6 36 00 $0ats
	inc hl			 ; fed8 23 $06ts
	djnz l_fed6		 ; fed9 10 fb $08/$0dts
	dec c			 ; fedb 0d $04ts
	jr nz, l_fed6		 ; fedc 20 f8 $07/$0cts
	ld ix, $fee8		 ; fede dd 21 e8 fe $0ets
	ld de, $00e8		 ; fee2 11 e8 00 $0ats
	call l_fe40		 ; fee5 cd 40 fe $11ts
;
	end
